For AI agents: A markdown version of this page is available at https://docs.datadoghq.com/api/latest/entity-risk-scores/get-entity-risk-score.md. A documentation index is available at /llms.txt.

Get Entity Risk Score

Note: This endpoint is in public beta and it’s subject to change. If you have any feedback, contact Datadog support.

GET https://api.ap1.datadoghq.com/api/v2/security-entities/risk-scores/{entity_id}https://api.ap2.datadoghq.com/api/v2/security-entities/risk-scores/{entity_id}https://api.datadoghq.eu/api/v2/security-entities/risk-scores/{entity_id}https://api.ddog-gov.com/api/v2/security-entities/risk-scores/{entity_id}https://api.us2.ddog-gov.com/api/v2/security-entities/risk-scores/{entity_id}https://api.uk1.datadoghq.com/api/v2/security-entities/risk-scores/{entity_id}https://api.datadoghq.com/api/v2/security-entities/risk-scores/{entity_id}https://api.us3.datadoghq.com/api/v2/security-entities/risk-scores/{entity_id}https://api.us5.datadoghq.com/api/v2/security-entities/risk-scores/{entity_id}

Overview

Get the risk score for a specific entity by its ID. Returns security risk assessment including risk score, severity, detected signals, misconfigurations, and identity risks.

Arguments

Path Parameters

Name

Type

Description

entity_id [required]

string

The URL-encoded unique identifier for the entity.

Response

OK

Response containing a single entity risk score

Expand All

Field

Type

Description

data [required]

object

An entity risk score containing security risk assessment information

attributes [required]

object

Attributes of an entity risk score.

accountIds [required]

[string]

Cloud account IDs associated with the entity.

configRisks [required]

object

Configuration risks associated with the entity

hasIdentityRisk [required]

boolean

Whether the entity has identity risks

hasMisconfiguration [required]

boolean

Whether the entity has misconfigurations

hasPrivilegedRole [required]

boolean

Whether the entity has privileged roles

isPrivileged [required]

boolean

Whether the entity has privileged access

isProduction [required]

boolean

Whether the entity is in a production environment

isPubliclyAccessible [required]

boolean

Whether the entity is publicly accessible

entityMetadata [required]

object

Metadata about the entity from cloud providers

accountID

string

Cloud account ID (AWS)

environments [required]

[string]

Environment tags associated with the entity

mitreTactics [required]

[string]

MITRE ATT&CK tactics detected

mitreTechniques [required]

[string]

MITRE ATT&CK techniques detected

projectID

string

Cloud project ID (GCP)

services [required]

[string]

Services associated with the entity

sources [required]

[string]

Data sources that detected this entity

subscriptionID

string

Cloud subscription ID (Azure)

entityName

string

Human-readable name of the entity.

entityProviders [required]

[string]

Cloud providers associated with the entity.

entityRoles

[string]

Roles associated with the entity.

entitySubTypes [required]

[string]

Sub-types associated with the entity.

entityType

string

Type of the entity (for example, aws_iam_user, aws_ec2_instance).

entityTypes

[string]

All types associated with the entity.

firstDetected [required]

int64

Timestamp when the entity was first detected (Unix milliseconds).

lastActivityTitle [required]

string

Title of the most recent signal detected for this entity.

lastDetected [required]

int64

Timestamp when the entity was last detected (Unix milliseconds).

riskScore [required]

int64

Current risk score for the entity.

riskScoreEvolution [required]

int64

Change in risk score compared to previous period.

severity [required]

enum

Severity level based on risk score Allowed enum values: critical,high,medium,low,info

signalsDetected [required]

int64

Number of risk-contributing security signals detected for this entity.

id [required]

string

Unique identifier for the entity

type [required]

enum

Resource type. Allowed enum values: SecurityEntityRiskScore

{
  "data": {
    "attributes": {
      "accountIds": [
        "222233334444",
        "3333333555555"
      ],
      "configRisks": {
        "hasIdentityRisk": false,
        "hasMisconfiguration": true,
        "hasPrivilegedRole": true,
        "isPrivileged": false,
        "isProduction": true,
        "isPubliclyAccessible": true
      },
      "entityMetadata": {
        "accountID": "123456789012",
        "environments": [
          "production",
          "us-east-1"
        ],
        "mitreTactics": [
          "Credential Access",
          "Privilege Escalation"
        ],
        "mitreTechniques": [
          "T1078",
          "T1098"
        ],
        "projectID": "my-gcp-project",
        "services": [
          "api-gateway",
          "lambda"
        ],
        "sources": [
          "cloudtrail",
          "cloud-security-posture-management"
        ],
        "subscriptionID": "a1b2c3d4-e5f6-7890-abcd-ef1234567890"
      },
      "entityName": "john.doe",
      "entityProviders": [
        "AWS"
      ],
      "entityRoles": [
        []
      ],
      "entitySubTypes": [
        "Root"
      ],
      "entityType": "aws_iam_user",
      "entityTypes": [
        "Root",
        "User Name"
      ],
      "firstDetected": 1778876604661,
      "lastActivityTitle": "Suspicious API call detected",
      "lastDetected": 1780064607093,
      "riskScore": 85,
      "riskScoreEvolution": 12,
      "severity": "critical",
      "signalsDetected": 15
    },
    "id": "arn:aws:iam::123456789012:user/john.doe",
    "type": "SecurityEntityRiskScore"
  }
}

Bad Request

API error response.

Expand All

Field

Type

Description

errors [required]

[object]

A list of errors.

detail

string

A human-readable explanation specific to this occurrence of the error.

meta

object

Non-standard meta-information about the error

source

object

References to the source of the error.

header

string

A string indicating the name of a single request header which caused the error.

parameter

string

A string indicating which URI query parameter caused the error.

pointer

string

A JSON pointer to the value in the request document that caused the error.

status

string

Status code of the response.

title

string

Short human-readable summary of the error.

{
  "errors": [
    {
      "detail": "Missing required attribute in body",
      "meta": {},
      "source": {
        "header": "Authorization",
        "parameter": "limit",
        "pointer": "/data/attributes/title"
      },
      "status": "400",
      "title": "Bad Request"
    }
  ]
}

Unauthorized

API error response.

Expand All

Field

Type

Description

errors [required]

[object]

A list of errors.

detail

string

A human-readable explanation specific to this occurrence of the error.

meta

object

Non-standard meta-information about the error

source

object

References to the source of the error.

header

string

A string indicating the name of a single request header which caused the error.

parameter

string

A string indicating which URI query parameter caused the error.

pointer

string

A JSON pointer to the value in the request document that caused the error.

status

string

Status code of the response.

title

string

Short human-readable summary of the error.

{
  "errors": [
    {
      "detail": "Missing required attribute in body",
      "meta": {},
      "source": {
        "header": "Authorization",
        "parameter": "limit",
        "pointer": "/data/attributes/title"
      },
      "status": "400",
      "title": "Bad Request"
    }
  ]
}

Forbidden

API error response.

Expand All

Field

Type

Description

errors [required]

[object]

A list of errors.

detail

string

A human-readable explanation specific to this occurrence of the error.

meta

object

Non-standard meta-information about the error

source

object

References to the source of the error.

header

string

A string indicating the name of a single request header which caused the error.

parameter

string

A string indicating which URI query parameter caused the error.

pointer

string

A JSON pointer to the value in the request document that caused the error.

status

string

Status code of the response.

title

string

Short human-readable summary of the error.

{
  "errors": [
    {
      "detail": "Missing required attribute in body",
      "meta": {},
      "source": {
        "header": "Authorization",
        "parameter": "limit",
        "pointer": "/data/attributes/title"
      },
      "status": "400",
      "title": "Bad Request"
    }
  ]
}

Not Found

API error response.

Expand All

Field

Type

Description

errors [required]

[object]

A list of errors.

detail

string

A human-readable explanation specific to this occurrence of the error.

meta

object

Non-standard meta-information about the error

source

object

References to the source of the error.

header

string

A string indicating the name of a single request header which caused the error.

parameter

string

A string indicating which URI query parameter caused the error.

pointer

string

A JSON pointer to the value in the request document that caused the error.

status

string

Status code of the response.

title

string

Short human-readable summary of the error.

{
  "errors": [
    {
      "detail": "Missing required attribute in body",
      "meta": {},
      "source": {
        "header": "Authorization",
        "parameter": "limit",
        "pointer": "/data/attributes/title"
      },
      "status": "400",
      "title": "Bad Request"
    }
  ]
}

Too many requests

API error response.

Expand All

Field

Type

Description

errors [required]

[string]

A list of errors.

{
  "errors": [
    "Bad Request"
  ]
}

Code Example

                  # Path parameters
export entity_id="arn:aws:iam::123456789012:user/john.doe"
# Use a Personal Access Token or Service Access Token
export DD_BEARER_TOKEN="<PERSONAL_ACCESS_TOKEN OR SERVICE_ACCESS_TOKEN>"

# Curl command
curl -X GET "https://api.ap1.datadoghq.com"https://api.ap2.datadoghq.com"https://api.datadoghq.eu"https://api.ddog-gov.com"https://api.us2.ddog-gov.com"https://api.uk1.datadoghq.com"https://api.datadoghq.com"https://api.us3.datadoghq.com"https://api.us5.datadoghq.com/api/v2/security-entities/risk-scores/${entity_id}" \ -H "Accept: application/json" \ -H "Authorization: Bearer ${DD_BEARER_TOKEN}"
"""
Get Entity Risk Score returns "OK" response
"""

from os import environ
from datadog_api_client import ApiClient, Configuration
from datadog_api_client.v2.api.entity_risk_scores_api import EntityRiskScoresApi

configuration = Configuration()
configuration.access_token = environ["DD_BEARER_TOKEN"]
configuration.unstable_operations["get_entity_risk_score"] = True
with ApiClient(configuration) as api_client:
    api_instance = EntityRiskScoresApi(api_client)
    response = api_instance.get_entity_risk_score(
        entity_id="arn:aws:iam::123456789012:user/john.doe",
    )

    print(response)

Instructions

First install the library and its dependencies and then save the example to example.py and run following commands:

    
DD_SITE="datadoghq.comus3.datadoghq.comus5.datadoghq.comdatadoghq.euap1.datadoghq.comap2.datadoghq.comuk1.datadoghq.comddog-gov.comus2.ddog-gov.com" DD_BEARER_TOKEN="<PERSONAL_ACCESS_TOKEN OR SERVICE_ACCESS_TOKEN>" python3 "example.py"
# Get Entity Risk Score returns "OK" response

require "datadog_api_client"
DatadogAPIClient.configure do |config|
  config.access_token = ENV["DD_BEARER_TOKEN"]
  config.unstable_operations["v2.get_entity_risk_score".to_sym] = true
end
api_instance = DatadogAPIClient::V2::EntityRiskScoresAPI.new
p api_instance.get_entity_risk_score("arn:aws:iam::123456789012:user/john.doe")

Instructions

First install the library and its dependencies and then save the example to example.rb and run following commands:

    
DD_SITE="datadoghq.comus3.datadoghq.comus5.datadoghq.comdatadoghq.euap1.datadoghq.comap2.datadoghq.comuk1.datadoghq.comddog-gov.comus2.ddog-gov.com" DD_BEARER_TOKEN="<PERSONAL_ACCESS_TOKEN OR SERVICE_ACCESS_TOKEN>" rb "example.rb"
// Get Entity Risk Score returns "OK" response

package main

import (
	"context"
	"encoding/json"
	"fmt"
	"os"

	"github.com/DataDog/datadog-api-client-go/v2/api/datadog"
	"github.com/DataDog/datadog-api-client-go/v2/api/datadogV2"
)

func main() {
	ctx := datadog.NewDefaultContext(context.Background())
	ctx = context.WithValue(ctx, datadog.ContextAccessToken, os.Getenv("DD_BEARER_TOKEN"))
	configuration := datadog.NewConfiguration()
	configuration.SetUnstableOperationEnabled("v2.GetEntityRiskScore", true)
	apiClient := datadog.NewAPIClient(configuration)
	api := datadogV2.NewEntityRiskScoresApi(apiClient)
	resp, r, err := api.GetEntityRiskScore(ctx, "arn:aws:iam::123456789012:user/john.doe")

	if err != nil {
		fmt.Fprintf(os.Stderr, "Error when calling `EntityRiskScoresApi.GetEntityRiskScore`: %v\n", err)
		fmt.Fprintf(os.Stderr, "Full HTTP response: %v\n", r)
	}

	responseContent, _ := json.MarshalIndent(resp, "", "  ")
	fmt.Fprintf(os.Stdout, "Response from `EntityRiskScoresApi.GetEntityRiskScore`:\n%s\n", responseContent)
}

Instructions

First install the library and its dependencies and then save the example to main.go and run following commands:

    
DD_SITE="datadoghq.comus3.datadoghq.comus5.datadoghq.comdatadoghq.euap1.datadoghq.comap2.datadoghq.comuk1.datadoghq.comddog-gov.comus2.ddog-gov.com" DD_BEARER_TOKEN="<PERSONAL_ACCESS_TOKEN OR SERVICE_ACCESS_TOKEN>" go run "main.go"
// Get Entity Risk Score returns "OK" response

import com.datadog.api.client.ApiClient;
import com.datadog.api.client.ApiException;
import com.datadog.api.client.v2.api.EntityRiskScoresApi;
import com.datadog.api.client.v2.model.SecurityEntityRiskScoreResponse;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = ApiClient.getDefaultApiClient();
    defaultClient.setAccessToken(System.getenv("DD_BEARER_TOKEN"));
    defaultClient.setUnstableOperationEnabled("v2.getEntityRiskScore", true);
    EntityRiskScoresApi apiInstance = new EntityRiskScoresApi(defaultClient);

    try {
      SecurityEntityRiskScoreResponse result =
          apiInstance.getEntityRiskScore("arn:aws:iam::123456789012:user/john.doe");
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling EntityRiskScoresApi#getEntityRiskScore");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}

Instructions

First install the library and its dependencies and then save the example to Example.java and run following commands:

    
DD_SITE="datadoghq.comus3.datadoghq.comus5.datadoghq.comdatadoghq.euap1.datadoghq.comap2.datadoghq.comuk1.datadoghq.comddog-gov.comus2.ddog-gov.com" DD_BEARER_TOKEN="<PERSONAL_ACCESS_TOKEN OR SERVICE_ACCESS_TOKEN>" java "Example.java"
// Get Entity Risk Score returns "OK" response
use datadog_api_client::datadog;
use datadog_api_client::datadogV2::api_entity_risk_scores::EntityRiskScoresAPI;

#[tokio::main]
async fn main() {
    let mut configuration = datadog::Configuration::new();
    configuration.set_unstable_operation_enabled("v2.get_entity_risk_score", true);
    let api = EntityRiskScoresAPI::with_config(configuration);
    let resp = api
        .get_entity_risk_score("arn:aws:iam::123456789012:user/john.doe".to_string())
        .await;
    if let Ok(value) = resp {
        println!("{:#?}", value);
    } else {
        println!("{:#?}", resp.unwrap_err());
    }
}

Instructions

First install the library and its dependencies and then save the example to src/main.rs and run following commands:

    
DD_SITE="datadoghq.comus3.datadoghq.comus5.datadoghq.comdatadoghq.euap1.datadoghq.comap2.datadoghq.comuk1.datadoghq.comddog-gov.comus2.ddog-gov.com" DD_API_KEY="<API-KEY>" DD_APP_KEY="<APP-KEY>" cargo run
/**
 * Get Entity Risk Score returns "OK" response
 */

import { client, v2 } from "@datadog/datadog-api-client";

const configuration = client.createConfiguration({
  authMethods: {
    AuthZ: {
      accessToken: process.env.DD_BEARER_TOKEN as string,
    },
  },
});
configuration.unstableOperations["v2.getEntityRiskScore"] = true;
const apiInstance = new v2.EntityRiskScoresApi(configuration);

const params: v2.EntityRiskScoresApiGetEntityRiskScoreRequest = {
  entityId: "arn:aws:iam::123456789012:user/john.doe",
};

apiInstance
  .getEntityRiskScore(params)
  .then((data: v2.SecurityEntityRiskScoreResponse) => {
    console.log(
      "API called successfully. Returned data: " + JSON.stringify(data)
    );
  })
  .catch((error: any) => console.error(error));

Instructions

First install the library and its dependencies and then save the example to example.ts and run following commands:

    
DD_SITE="datadoghq.comus3.datadoghq.comus5.datadoghq.comdatadoghq.euap1.datadoghq.comap2.datadoghq.comuk1.datadoghq.comddog-gov.comus2.ddog-gov.com" DD_BEARER_TOKEN="<PERSONAL_ACCESS_TOKEN OR SERVICE_ACCESS_TOKEN>" tsc "example.ts"